/****************************************************************************
 * A class for keeping release information
 *
 * @author: Jussi Stader <J.Stader@ed.ac.uk>
 * Updated: Sat Jun 16 01:48:45 2007 by Jeff Dalton
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 *
 *****************************************************************************
 */
package ix.iview;

/** I-DE 2.3 03-Oct-02 */
/** I-DE 3.1 27-Jun-03 */
/** I-DE 3.2 18-Dec-03 */
/** I-DE 4.0 31-Aug-04 */
/** I-DE 4.1 23-Feb-05 */
/** I-DE 4.2 31-Aug-05 */
/** I-DE 4.2 31-Aug-05 */
/** I-DE 4.2+ 07-Sep-05 */
/** I-DE 4.4 07-Sep-06 */
public class IDERelease {
  public static String name = "I-DE";
  public static String version = "4.5";
  public static String date    = "28-May-07";
}


/** Changes              
 * 2007************************************************************************
 * May07
 *    28- 4.5 release
 * Apr07
 *    23- debugged ActionEditorpanel problem with looping tree selection
 * Mar07
 *    26- debugged collecting changes (now robust against empty value maps)
 *    15- debugged object class tree (duplicates on selection problem)
 *        Added generic constraints to grammar, displayed as table
 *    12- debugged naming problem in editing sub-activity from domain panel
 *    07- changed form panels from mouse events to actions; implemented 
 *        popups for form panel bits that have buttons
 *    05- implemented toggle for sorting overviews (refinements,...)
 *    01- debugged problems with loading/saving domain name and comments
 *      - added annotations to refinements (not GUI yet) and comments to domain
 * Feb07
 *    08- improved ConstraintEditor for compute constraints; values in
 *        constraints retain their types; domain can save if remove fails
 * Jan07
 *    29- solved problems with clearing and loading domains, updating construct
 *        names, finding originals, etc. (Mainly SetEditor and UIDomain files)
 *    25- displaying syntax problem in SpecEd, 
 *    22- changed some names, removed DecEd columns
 *    18- non-editable boolean table cells are now not bold (IXTable)!
 *        inherited properties are plain, own are bold (AROEditorPanel)
 *    11- fixed problem with ObjectSystemGenerator (root now added as parent)
 *        fixed problem with domains not clearing properly (clear and load)
 *        changed minimise/deminimise: popup for smaller/lgr; minimised weight
 *        improved devider resize on split panes (Declaration editor!)
 *    08- fixed small DeclarationEditor problem
 * 2006************************************************************************
 * Dec06
 *    07- implemented minimise/de-minimise for FormPanel components (AbstEdPan)
 *    11- debugged tree (tree-menu and getRoot in UIDomain)
 * Nov06
 *    02- fixed repeated question on close problem (DomainEditorFrame)
 *      - fixed problem with empty refinement in graphical editor
 *    06- added left-layout to graphical editor
 *      - improved Undo
 *    09- tidied up iview (moved things to iview.util and iface.ui)
 * Oct06
 *    02- added editProperty in AROEditorPanel
 *    04- bug-fix for invisiable refinements from command-line domain (setEds)
 *      - start on search facility (nothing visible yet) 
 *    05- search added to editor - no proper gui yet.
 *    12- search available for activities and object classes
 *      - improved EditorPanel behaviour, especially ListEditorPanel
 *      - improved loading and closing behaviour (less fake changes detected)
 *    26- improved search (button sizes, <return> starts search)
 *      - improved sub-panel closing behaviour
 *      - re-organised the order of notes in this file
 * Sep06
 *    05- MAJOR: First release of object system integrated into I-DE
 *    21- fixed text selection in table cells (cut/paste) and URL display
 *        from agenda tables
 *      - fixed problems with creating root object
 *    25- fixed problem with tree table expand/collapse
 *      - updated HTMLPanel with Jeff's version 
 *    27- fixed problems with bold parents (AbstractTTM)
 *      - changed FourFields to also use Font (int)
 * May06
 *    01- First version of ObjectClass editor panel. No undo, no property
 *        editing, no link to specs
 * Apr06  major changes affecting most files
 *        added ObjectClass definitions, fixed problem with hasChanged
 *        re-organised UIDomain to use UISetEditors
 * Jan06
 *    10- moved to Java1.5 and split DomainEditor and DomainEditorFrame 
 *        (DomainEditor, DomainEditorFrame, UIUtil, JPreferencesDialog, 
 *        PropertiesApplication, JPropertiesManager, UIDomain, UIARO, 
 *        AConstructFramePanel, AROEditorPanel, ActionEditorPanel, 
 *        ActionFormModel, DomainEditor, GlobalFramePanel, GrammarEditorPanel,
 *        IDEPreferencesDialog, IDEPropertiesManager, DomainEditorFrame)
 * 2005************************************************************************
 * Oct05
 *      - implementing ARO editor and rationalising editing frames and panels
 *    24- finished splitting UndoManager off AConstructFramePanel
 * Sep05
 *    05- made I-DE stand-alone take domain argument (DomainEditor)
 *      - improved problem with multiple setting of domain (DomainEditor)
 *      - fixed column problem (AgendaItemTableModel)
 *    07- improved domain library finding in command-line argument processing
 * Aug05
 *    22- switched off selection column (nothing uses it!) (IXTable,
 *        AgendaItemTableModel, GlobalFormPanel)
 *    24- made I-DE cope with null constraint relation (for compute) (IVUtil)
 *    29- changed "Exit Application" to "Exit" (JFrameMT)
 *      - changed overwrite handling (UIDomain)
 *      - changed updates to tree table models (AbstractTreeTableModel,
 *        ActionTreeTableModel)
 *    31- fixed a problem with node sorting (IVUtil)
 *      - fixed a problem with graphics view editing (GExpansionEditor,
 *        ExpansionModel)
 *      - fixed a problem with collapsing tree tables (AbstractTreeTableModel,
 *        ActionTreeTableModel, GlobalFormPanel)
 *      - removed references to Debug.error (AbstractIFormModel, UIRefinement,
 *        UIDomain, JPropertiesManager, AgendaTableViewer, ExpansionModel,
 *        GExpansionEditor)
 * May05
 *    04- changed mouse reaction on Activity Tree: enabled more right-clicks,
 *        removed left-click on node (confused testers!), 
 *        (ActionEditorPanel, UIUtils, JObjectPopup, JObjectMenu)
 *      - implemented refresh vs reset for tables (AbstractTreeTableModel)
 *      - removed look-up bug for expansions (UIDomain)
 *    09- added selection column to tables (<all>*TableModel, IXTable,
 *        AgendaTableViewer, GlobalFormPanel)
 * Apr05
 *    03- modularised properties management (DomainEditor, JPreferencesDialog,
 *        JPropertiesManager, PropertiesApplication, IDEPropertiesManager,
 *        IDEPreferencesDialog)
 * Feb05
 *    14- fixed a problem with overwrite-handling, especially inserting domains
 *        (UIDomain)
 *    14- fixed a problem with graph comparisons (IGraph, UIRefinement)
 * Jan05
 *    10- fixed a problem with constraint updates (ActionFormModel, UIUtil, 
 *        AbstractIFormModel)
 *    10- fixed a problem with toolbar preferences (DomainEditor) and changed 
 *        toolbar.
 *    10- fixed small problem with inserting variables into definitions(IVUtil)
 *    12- added cancel option to changing name and handling overwrites
 *        (UIDomain)
 *    13- added viewChanges for panel edits that are not in draft domain and
 *        viewChangesFromOriginal for panel edits that are not in published
 *        domain (DomainEditor, ConstructFraming, AConstructFramePanel, 
 *        ActionEditorPanel,  GlobalFramePanel, UIDomain, UIRefinement,
 *        UIObject, IVUtil)
 * 2004************************************************************************
 * Dec04- fixed display problem with single panel style (JFrameMTP)
 *      - incorporated Jeff's updates (AgendaTableViewer,AgendaItemTableModel)
 *      - added right-click for action-summary-tree (go to expansion)
 *        (ActionEditorPanel) 
 * Nov04- changed ActionListeners to CatchingActionListeners (UIUtil, JFrameMT,
 *        IXDefaultCellEditor, AboutFrame, HTMLFrame, HelpFrame, IXToolItem,
 *        AgendaTableViewer, GExpansionEditor, ActionEditorPanel, DomainEditor)
 *      - sorted out simple editor's problem with node ids and orderings etc.
 *        (UIRefinement, IVUtil, ExpansionModel, ActionFormModel,
 *        ActionEditorPanel
 *      - small changes to GUI: added a few toolbar and menu items, changed 
 *        some labels (DomainEditor, DeclarationEditor, )
 *      - added "declare all vars" for domain (UIDomain, UIRefinement, IVUtil,
 *        GlobalFramePanel, DomainEditor)
 *      - changed "check consistency" of domain to go through all refinements
 *        (GlobalEditorPanel, UIDomain)
 *      - fixed some small bugs (GlobalFormPanel)
 * Oct04- fixed variable declaration problem (JConstraintEditor,
 *        ConstraintEditor, DeclarationEditor, UIRefinement, IVUtil)
 *      - fixed IP2 problem of mouse clicks in text fields (AgendaTableViewer,
 *        HTMLFrame)
 * Jun04- major changes to preferences dialogue
 * May04- JFrameMT: put file chooser, open/save, and help at this level
 *        AboutFrame: small improvements
 * Mar04- AbstractIFormModel: changed some permissions
 * Feb04- Pulled generic constraint editing stuff into JConstraintEditor class
 *        Chenges to label renderers
 * Jan04- Tables: improved width adjustments, parameterised name column and 
 *        tree icon column. Moved TablePopupMenu to table package
 * 2003************************************************************************
 * Dec03
 *    18- fixed some utilities and the agenda table viewer for Jeff
 *      - added findColumn to IXTable
 *      - AConstructFrameEditor: fixed a problem with always-save mode and
 *        set to always-save to remove dialogue (undo makes this sensible).
 *      - removed modify draft button
 * Sep03
 *    22- AConstructFramePanel, ActionEditorPanel: 
 *        no undo/redo for graphical editor; put in catch for non-IFormPanel
 *        implemented afterSwitching 
 *      - GrammarEditorPanel:
 *        fixed constraint pattern problem
 * Jul03- implemented undo
 **/

/*Todos************************
 * - lists as text
 * - right-click
 * - order of refinements (use ix.util.StableHashMap instead of HashMap)
 * - new constraints (resources, durations, compute, ...)
 * - bail out of problem messages (extra option?)
 * 
 */
/*Big Todos************************
 * - grammars and lexica
 * - graph
 * - error fixing support
 * - modelling support
 *
 */
