/* Author: Jeff Dalton
 * Updated: Sun May 26 15:37:15 2002 by Jeff Dalton
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 */

package ix.iface.util;

import javax.swing.*;
import java.util.*;

/**
 * A subclass of JLabel that overrides methods not needed when rendering.
 * See the documentation for javax.swing.DefaultListCellRenderer
 * and javax.swing.table.DefaultTableCellRenderer.  In many cases, it
 * may be better to extend one of those classes instead of this one.
 */
public class RendererJLabel extends JLabel {

    public RendererJLabel() {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   boolean oldValue, 
				   boolean newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   byte oldValue,
				   byte newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   char oldValue,
				   char newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   double oldValue,
				   double newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName, 
				   float oldValue,
				   float newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   int oldValue,
				   int newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   long oldValue,
				   long newValue) {
    }

    /** Overridden for performance reasons. */
    protected  void firePropertyChange(String propertyName,
				       Object oldValue,
				       Object newValue) {
    }

    /** Overridden for performance reasons. */
    public void firePropertyChange(String propertyName,
				   short oldValue, 
				   short newValue) {
    }

    /** Overridden for performance reasons. */
    public void repaint(long tm, int x, int y, int width, int height) { }

    /** Overridden for performance reasons. */
    public void repaint(java.awt.Rectangle r) { }

    /** Overridden for performance reasons. */
    public void revalidate() { }

    /** Overridden for performance reasons. */
    public void validate() { }

}

 
